﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;
private import map;
private import fmfloader;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count = 0;		// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	enum MOTION{
		IDLE = 0,
		RUN,
		SHIZUMU,
	};
	int ashi = 0;					//前回だした足
	MOTION motion = MOTION.IDLE;
	int anime = 0;
	int anime_int = 0;
	int anime_intdef = 0;
	int anime_max = 0;
	int idoucount = 0;
	int sizumu = 0;
	float sizumu_y = 0;
	float jump = 0;
	Map map1; 		// 地形
	Layer2D layer1; // 地形奥
	int view_point_x = 0;	//カメラ
	int view_point_y = 0;	//カメラ	

	int player_x = 0;
	int player_y = 0;
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];
	
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("maptip","resource/image/maptip.bmp" , [0,255,0]);
		Hell_loadTexture("bg","resource/image/bg.bmp" , [0,255,0]);
		Hell_loadTexture("msg","resource/image/msg.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("run",         "resource/sound/landing.wav");
		Hell_loadWAV("suirun",         "resource/sound/punch_dis.wav");
		Hell_loadWAV("miss",         "resource/sound/punch.wav");

		loadFMF("resource/map/map.fmf");
		map1 = new Map();
		map1.init( this, layer1 );

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 0;		//ゲーム終了までの残り時間

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
		set_motion( MOTION.IDLE );
		player_x = 0;
		player_y = ( ( 32 * 8 ) - 64 );

		Hell_stopBgm( 1000 );
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		stage_start_count++;
		if ( stage_start_count == ( 60 * 3 ) )
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if (stage_start_count < (60 * 4))
		{
			Hell_drawTexture("msg"
				, 0
				, 0
				, 0
				, 0
				, getScreenWidth( ) , getScreenHeight( )
				, 1.0 , 1.0 );
		}
		int mx = 260;
		if ( stage_start_count < ( 60 * 1 ) )
		{
			Hell_drawFont(" 3 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 2 ) )
		{
			Hell_drawFont(" 2 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 3 ) )
		{
			Hell_drawFont(" 1 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( ( stage_start_count >= ( 60 * 3 ) ) && (stage_start_count < (60 * 4)))
		{
			Hell_drawFont("GO!" , mx, 180 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 200 , 4 , 255,255,255);
/*
		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
*/
		str = std.string.format( "%dm", player_x );
//		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 260, 250 , 4 , 255,255,255);
/*
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}
*/
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PURESS Z OR 1 BUTTON TO EXIT" , 100, 300 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 320 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			effect_move( );
			system_move( );
			SeneStart_move( );
			map1.move( );

			break;
		case SCENE.CLEAR:
			//クリア
			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			map1.draw( );
			system_draw( );
			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			map1.draw( );
			system_draw( );
			effect_draw( );
			SeneStart_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			map1.draw( );
			system_draw( );
			effect_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			map1.draw( );
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			map1.draw( );
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count++;

		int suimen_flg = 0;
		if ( ( player_x >= ( 32 * 3 ) ) && (player_x <= ( 32 * 17 )))
		{
			suimen_flg = 1;
			if ( motion == MOTION.SHIZUMU )
			{
				if ( sizumu == 0 )
				{
					Hell_playWAV( "miss", 0, -1 );
					int i;
					for ( i = 0; i < 100; i++ )
					{
						float dir = cast( float )Hell_randInt(0, 60) + 270.0f - 30.0f;
						float spd = cast( float )Hell_randInt(0, 100) / 10.0f;
						create_effect( 0, player_x, player_y + 64, dir, spd );
					}
				}
				sizumu = 1;
				jump = jump + ( 0.98f * 1.0f );
			}
		}
		sizumu_y = sizumu_y + ( jump / 400.0f );

		int idoucount_def = 6;
//		int idoucount_def = 20;//受付時間
		int susumu_spd = 1;
		if ( sizumu == 0 )
		{
			if(keypad.isPushLeft(true))
			{
				//左キー
				bool susumu = false;
				switch ( ashi )
				{
					case 0:	//どちらも出していない
						susumu = true;
						break;
					case 1:	//右を出した
						susumu = true;
						break;
					case 2:	//左を出した
						break;
					default:
						break;
				}
				if ( susumu == true )
				{
					ashi = 2;
					if ( suimen_flg == 1 )
					{
						Hell_playWAV( "suirun", 0, -1 );
					}
					else
					{
						Hell_playWAV( "run", 0, -1 );
					}
					if ( motion == MOTION.IDLE )
					{
						set_motion( MOTION.RUN );
					}
					idoucount = idoucount_def;
				}
			}
			if(keypad.isPushRight(true))
			{
				//右キー
				bool susumu = false;
				switch ( ashi )
				{
					case 0:	//どちらも出していない
						susumu = true;
						break;
					case 1:	//右を出した
						break;
					case 2:	//左を出した
						susumu = true;
						break;
					default:
						break;
				}
				if ( susumu == true )
				{
					ashi = 1;
					if ( suimen_flg == 1 )
					{
						Hell_playWAV( "suirun", 0, -1 );
					}
					else
					{
						Hell_playWAV( "run", 0, -1 );
					}
					if ( motion == MOTION.IDLE )
					{
						set_motion( MOTION.RUN );
					}
					idoucount = idoucount_def;
				}
			}
		}
		idoucount--;
		if (idoucount < 0)
		{
			idoucount = 0;
			if ( suimen_flg == 1 )
			{
				set_motion( MOTION.SHIZUMU );
			}
			else
			{
				set_motion( MOTION.IDLE );
			}
		}
		else
		{
			player_x += susumu_spd;
			if ( suimen_flg == 1 )
			{
				float dir = cast( float )Hell_randInt(0, 60) + 180.0f;
				float spd = cast( float )Hell_randInt(0, 100) / 10.0f;
				create_effect( 0, player_x - 16, player_y + 64, dir, spd );
			}
		}

		anime_int--;
		if ( anime_int < 0 )
		{
			anime_int = anime_intdef;
			anime++;
			if ( anime >= anime_max )
			{
				anime = 0;
				switch( motion )
				{
					case MOTION.IDLE:
						break;
					case MOTION.RUN:
//						set_motion( MOTION.IDLE );
						break;
					default:
						break;
				}
			}
		}
		player_y += cast(int)sizumu_y;


		if ( ( player_x >= 640 ) || ( player_y > ( 360 + 64 ) ) )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	void set_motion( MOTION type )
	{
		motion = type;
		anime = 0;
		switch( motion )
		{
			case MOTION.IDLE:
				anime_intdef = 0;
				anime_max = 0;
				break;
			case MOTION.RUN:
				anime_intdef = 2;
				anime_max = 6;
				break;
			case MOTION.SHIZUMU:
				anime_intdef = 0;
				anime_max = 0;
				break;
			default:
				break;
		}
		anime_int = anime_intdef;
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		
		//キャラの表示
		int sx = 0;
		int sy = 0;
		int sizex = 64;
		int sizey = 64;
		switch( motion )
		{
			case MOTION.IDLE:
				sx = 0;
				sy = 128;
				break;
			case MOTION.RUN:
				sx = 0;
				sy = 0;
				break;
			case MOTION.SHIZUMU:
				sx = 128;
				sy = 128;
				break;
			default:
				break;
		}
		int dy = ( 32 * 8 ) - 64;
		Hell_drawTexture("maptip"
			, player_x - 32
			, player_y
			, sx + ( anime * sizex )
			, sy
			, sizex, sizey
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		
		
		
		
		
		
/*		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );
		}
*/
		str = std.string.format( "%dm", player_x );
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 280, 20 , 3 , r,g,b);

//		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , 4 , 255,255,255);
/*
		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);
*/	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
	//-----------------------------------------------------------------------------
	//	FMFファイルの読み込み
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void loadFMF(char[] filepath)
	{
		scope fmf = new FMFLoader(filepath);
		layer1 = fmf.getLayer(0); // 地形
		Hell_write(layer1.width);
		Hell_write(layer1.height);
		Hell_write(layer1.chip_width);
		Hell_write(layer1.chip_height);
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				
				//タイプによってパラメータを分けるといいかも
				effect[i].r = Hell_randInt(0, 255);	//色
				effect[i].g = Hell_randInt(0, 255);	//色
				effect[i].b = Hell_randInt(0, 255);	//色
				effect[i].zoom_x = 0.2;	//拡大率
				effect[i].zoom_y = 0.2;	//拡大率
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x , effect[i].zoom_y
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_cosEx( effect[i].dir ) * effect[i].speed;
				float vy = Hell_sinEx( effect[i].dir ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//タイプによって動きを分けるといいかも
				effect[i].zoom_x -= 0.001;	//
				effect[i].zoom_y -= 0.001;	//
				if ( effect[i].zoom_x < 0.0 )
				{
					effect[i].zoom_x = 0.0;
				}
				if ( effect[i].zoom_y < 0.0 )
				{
					effect[i].zoom_y = 0.0;
				}

				effect[i].alpha -= 8;	//透明度
				if ( effect[i].alpha < 0 )
				{
					effect[i].exist = 0;	//消える 
				}
			}
		}
	}
}


